# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ADHybridHealthService::Mgmt::V2014_01_01
  module Models
    #
    # The connect details.
    #
    class Connector

      include MsRestAzure

      # @return [String] The connector Id.
      attr_accessor :connector_id

      # @return [String] The connector Id.
      attr_accessor :id

      # @return [String] The connector name.
      attr_accessor :name

      # @return [Integer] The connector version
      attr_accessor :version

      # @return [String] The connector type.
      attr_accessor :type

      # @return [String] The connector description.
      attr_accessor :description

      # @return [String] The schema xml for the connector.
      attr_accessor :schema_xml

      # @return The password management settings of the connector.
      attr_accessor :password_management_settings

      # @return The password hash synchronization configuration of the
      # connector.
      attr_accessor :password_hash_sync_configuration

      # @return [DateTime] The date and time when this connector was created.
      attr_accessor :time_created

      # @return [DateTime] The date and time when this connector was last
      # modified.
      attr_accessor :time_last_modified

      # @return [Array<Partition>] The partitions of the connector.
      attr_accessor :partitions

      # @return [Array<RunProfile>] The run profiles of the connector.
      attr_accessor :run_profiles

      # @return [Array<String>] The class inclusion list of the connector.
      attr_accessor :classes_included

      # @return [Array<String>] The attribute inclusion list of the connector.
      attr_accessor :attributes_included


      #
      # Mapper for Connector class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Connector',
          type: {
            name: 'Composite',
            class_name: 'Connector',
            model_properties: {
              connector_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'connectorId',
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'version',
                type: {
                  name: 'Number'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              schema_xml: {
                client_side_validation: true,
                required: false,
                serialized_name: 'schemaXml',
                type: {
                  name: 'String'
                }
              },
              password_management_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'passwordManagementSettings',
                type: {
                  name: 'Object'
                }
              },
              password_hash_sync_configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'passwordHashSyncConfiguration',
                type: {
                  name: 'Object'
                }
              },
              time_created: {
                client_side_validation: true,
                required: false,
                serialized_name: 'timeCreated',
                type: {
                  name: 'DateTime'
                }
              },
              time_last_modified: {
                client_side_validation: true,
                required: false,
                serialized_name: 'timeLastModified',
                type: {
                  name: 'DateTime'
                }
              },
              partitions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'partitions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'PartitionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Partition'
                      }
                  }
                }
              },
              run_profiles: {
                client_side_validation: true,
                required: false,
                serialized_name: 'runProfiles',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'RunProfileElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'RunProfile'
                      }
                  }
                }
              },
              classes_included: {
                client_side_validation: true,
                required: false,
                serialized_name: 'classesIncluded',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              attributes_included: {
                client_side_validation: true,
                required: false,
                serialized_name: 'attributesIncluded',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
