# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ADHybridHealthService::Mgmt::V2014_01_01
  module Models
    #
    # The forest summary for an ADDS domain.
    #
    class ForestSummary

      include MsRestAzure

      # @return [String] The forest name.
      attr_accessor :forest_name

      # @return [Integer] The domain count.
      attr_accessor :domain_count

      # @return [Integer] The site count.
      attr_accessor :site_count

      # @return [Integer] The number of domain controllers that are monitored
      # by Azure Active Directory Connect Health.
      attr_accessor :monitored_dc_count

      # @return [Integer] The total domain controllers.
      attr_accessor :total_dc_count

      # @return [Array<String>] The list of domain controller names.
      attr_accessor :domains

      # @return [Array<String>] The list of site names.
      attr_accessor :sites


      #
      # Mapper for ForestSummary class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ForestSummary',
          type: {
            name: 'Composite',
            class_name: 'ForestSummary',
            model_properties: {
              forest_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'forestName',
                type: {
                  name: 'String'
                }
              },
              domain_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'domainCount',
                type: {
                  name: 'Number'
                }
              },
              site_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'siteCount',
                type: {
                  name: 'Number'
                }
              },
              monitored_dc_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'monitoredDcCount',
                type: {
                  name: 'Number'
                }
              },
              total_dc_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'totalDcCount',
                type: {
                  name: 'Number'
                }
              },
              domains: {
                client_side_validation: true,
                required: false,
                serialized_name: 'domains',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              sites: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sites',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
